function WendellFreeLibraryTB_Include(uri)
{
	var service = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
					.getService(Components.interfaces["mozIJSSubScriptLoader"]);
	service.loadSubScript(uri);
}

//******************************************************************
// Get access to the JavaScript console (for debugging)
//******************************************************************
const WendellFreeLibraryTB_ConsoleService =
      Components.
          classes['@mozilla.org/consoleservice;1'].
              getService(Components.interfaces.nsIConsoleService);

//******************************************************************
// Log a message on the JavaScript console (for debugging)
//******************************************************************
function WendellFreeLibraryTB_Log(aMessage)
{
    WendellFreeLibraryTB_ConsoleService.logStringMessage('WendellFreeLibrary_Toolbar: ' + aMessage);
}
//******************************************************************
// Get access to the preferences service
//******************************************************************
var WendellFreeLibraryTB_PrefService = 
        Components.classes["@mozilla.org/preferences-service;1"].
           getService(Components.interfaces.nsIPrefService);

//******************************************************************
// Get our preferences branch
//******************************************************************
var WendellFreeLibraryTB_Branch = 
        WendellFreeLibraryTB_PrefService.getBranch("wendelllibrarytoolbar.");


//******************************************************************
// Load preferences into globals
var WendellFreeLibraryTB_maxhistory   = WendellFreeLibraryTB_Branch.getIntPref("maxhistory");
var WendellFreeLibraryTB_target       = WendellFreeLibraryTB_Branch.getCharPref("target");

//******************************************************************
// Search history list
//******************************************************************
var WendellFreeLibraryTB_SearchHistory       = null;

//******************************************************************
// Insert into search history
//******************************************************************
function WendellFreeLibraryTB_insertIntoSearchHistory(s)
{
	if (WendellFreeLibraryTB_SearchHistory == null) {
	  //WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_insertIntoSearchHistory: WendellFreeLibraryTB_SearchHistory is NULL");
	  WendellFreeLibraryTB_SearchHistory = 
		new WendellFreeLibraryTB_searchHistoryElement(s);
	} else {
	  var sh = WendellFreeLibraryTB_SearchHistory;
	  //WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_insertIntoSearchHistory: sh.searchTerms = '"+sh.searchTerms+"'");
	  if (sh.searchTerms == s) {
	    sh.timestamp = new Date();
	  } else {
	    while (sh.next != null) {
	      //WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_insertIntoSearchHistory: sh.next.searchTerms = '"+sh.next.searchTerms+"'");
	      if (sh.next.searchTerms == s) {
		sh.next = sh.next.next;
		break;
	      }
	      sh = sh.next;
	    }
	    var ns = new WendellFreeLibraryTB_searchHistoryElement(s);
	    ns.next = WendellFreeLibraryTB_SearchHistory;
	    WendellFreeLibraryTB_SearchHistory = ns;
	    if (WendellFreeLibraryTB_maxhistory > 0) {
	      sh = WendellFreeLibraryTB_SearchHistory;
	      for (var count=1; sh != null && 
				count < WendellFreeLibraryTB_maxhistory; count++) {
		sh = sh.next;
	      }
	      if (sh != null) sh.next = null;
	    }
	  }
	}
	// re-write history file
	WendellFreeLibraryTB_SaveSearchHistory();
	
	// update search history menu:

	// Get the menupopup element that we will be working with
	var menu = document.getElementById("WendellFreeLibraryTB-SearchTermsMenu");
	
	// Remove all of the items currently in the popup menu
	for(var i=menu.childNodes.length - 1; i >= 0; i--)
	{
		menu.removeChild(menu.childNodes.item(i));
	}
	
	// Walk the history list, inserting search terms
	var h = WendellFreeLibraryTB_SearchHistory;
	while (h != null) {
	  // Create a new menu item to be added
	  var tempItem = document.createElement("menuitem");

	  // Set the new menu item's label
	  tempItem.setAttribute("label", h.searchTerms);

	  // Add the item to our menu
	  menu.appendChild(tempItem);

	  // On to the next element
	  h = h.next;
	}
}

//******************************************************************
// Create a fresh search history element
//******************************************************************
function WendellFreeLibraryTB_searchHistoryElement(s)
{
	this.searchTerms = s;
	this.timestamp   = new Date();
	this.next	 = null;
	this.insert	 = WendellFreeLibraryTB_insertIntoSearchHistory;
}
	
//******************************************************************
// Save search history
//******************************************************************
function WendellFreeLibraryTB_SaveSearchHistory()
{
	var buffer = "";
	var h = WendellFreeLibraryTB_SearchHistory;
	while (h != null) {
	  buffer = buffer + h.timestamp.getTime() + "\t" + h.searchTerms + "\n";
	  h = h.next;
	}

	// get profile directory
	var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
	// Append filename
        file.append("WendellFreeLibraryToolbarHistory.txt");
	// Get an output stream
        var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
				.createInstance(Components.interfaces.nsIFileOutputStream);

	// Open stream
	foStream.init(file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
	// Write the data
	foStream.write(buffer, buffer.length);
	// Close the file
	foStream.close();
}

var WendellFreeLibraryTB_SearchHistory_Loaded = false;

//******************************************************************
// Load saved search history
//******************************************************************
function WendellFreeLibraryTB_LoadSearchHistory()
{
	if (WendellFreeLibraryTB_SearchHistory_Loaded) return;

	// get profile directory
	var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
	// Append filename
        file.append("WendellFreeLibraryToolbarHistory.txt");

	//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_LoadSearchHistory(): file.path = '"+file.path+"'");
        // Initialize buffer
	var buffer = "";
	// Get a file stream
	var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
				.createInstance(Components.interfaces.nsIFileInputStream);
	// And a scriptable stream
	var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
				.createInstance(Components.interfaces.nsIScriptableInputStream);
	// Open the streams
	fstream.init(file, -1, 0, 0);
	sstream.init(fstream);
	// Read the data in 4K chunks
	var str = sstream.read(4096);
	while (str.length > 0) {
       	  buffer += str;
	  str = sstream.read(4096);
	}
	// Close the streams
	sstream.close();
	fstream.close();

	//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_LoadSearchHistory(): buffer = '"+buffer+"'");

	// Initialize the history
	WendellFreeLibraryTB_SearchHistory = null;
	var lastHead = null;
	// Get the menupopup element that we will be working with
	var menu = document.getElementById("WendellFreeLibraryTB-SearchTermsMenu");
	
	// Remove all of the items currently in the popup menu
	var i;
	for(i = menu.childNodes.length - 1; i >= 0; i--)
	{
		menu.removeChild(menu.childNodes.item(i));
	}
	var bufferlines = buffer.split("\n");
	//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_LoadSearchHistory(): bufferlines.length = "+bufferlines.length);
	for (i = 0; i < bufferlines.length; i++)
	{
		if (bufferlines[i] == "") continue;
		//WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_LoadSearchHistory(): bufferlines["+i+"] = '"+bufferlines[i]+"'");
		var timesearch = bufferlines[i].split("\t");
		var newhist = new WendellFreeLibraryTB_searchHistoryElement(timesearch[1]);
		newhist.timestamp.setTime(timesearch[0]);
		if (lastHead == null) {
			WendellFreeLibraryTB_SearchHistory = newhist;
		} else {
			lastHead.next = newhist;
		}
		lastHead = newhist;
		// Create a new menu item to be added
		var tempItem = document.createElement("menuitem");
		// Set the new menu item's label
		tempItem.setAttribute("label", newhist.searchTerms);
		// Add the item to our menu
		menu.appendChild(tempItem);
		
	}
	WendellFreeLibraryTB_SearchHistory_Loaded = true;	
}

//******************************************************************
// Handle <Return> (or <Enter>) key presses in the search box
//******************************************************************
function WendellFreeLibraryTB_KeyHandler(event)
{
     if(event.keyCode == event.DOM_VK_RETURN)
	    WendellFreeLibraryTB_SearchCWMars(event);
}

//******************************************************************
// Search CW Mars
//******************************************************************
function WendellFreeLibraryTB_SearchCWMars(event)
{
     // This variable will hold the URL we will browse to
     var URL = "http://bark.cwmars.org/eg/opac/results?";

     // This variable will tell us whether our search box is empty or not
     var isEmpty = false;

     // Get a handle to our search terms box (the <menulist> element)
     var searchTermsBox = document.getElementById("WendellFreeLibraryTB-SearchTerms");
     // Get the value in the search terms box, trimming whitespace as necessary
     // See the TutTB_TrimString() function farther down in this file for details
     // on how it works.
     var searchTerms = WendellFreeLibraryTB_TrimString(searchTermsBox.value);

     if(searchTerms.length == 0) // Is the search terms box empty?
	isEmpty = true;         // If so, set the isEmpty flag to true
     else {
	// Insert search terms into history
	WendellFreeLibraryTB_insertIntoSearchHistory(searchTerms);
	// Now convert searchTerms to a valid URI
	searchTerms = WendellFreeLibraryTB_ConvertTermsToURI(searchTerms);
     }

     //WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_SearchCWMars: searchTerms = " + searchTerms);

     URL = URL + "fi:item_type=" + document.getElementById("WendellFreeLibraryTB_searchformat").selectedItem.value;
     URL = URL + "&qtype=" + document.getElementById("WendellFreeLibraryTB_searchtype").selectedItem.value;
     URL = URL + "&locg=" + document.getElementById("WendellFreeLibraryTB_searchscope").selectedItem.value;
     URL = URL + "&query=" + searchTerms;

     WendellFreeLibraryTB_LoadURL(URL,"");	
}

//******************************************************************
// The WendellFreeLibraryTB_TrimString() function will trim all leading and trailing whitespace
// from the incoming string, and convert all runs of more than one whitespace
// character into a single space. The altered string gets returned.
//******************************************************************
function WendellFreeLibraryTB_TrimString(string)
{
    // If the incoming string is invalid, or nothing was passed in, return empty
    if (!string)
        return "";

    string = string.replace(/^\s+/, ''); // Remove leading whitespace
    string = string.replace(/\s+$/, ''); // Remove trailing whitespace

    // Replace all whitespace runs with a single space
    string = string.replace(/\s+/g, ' ');

    return string; // Return the altered value
}
//******************************************************************
// The WendellFreeLibraryTB_ConvertTermsToURI() function converts an incoming string of search
// terms to a safe value for passing into a URL.
//******************************************************************
function WendellFreeLibraryTB_ConvertTermsToURI(terms)
{
    // Create an array to hold each search term
    var termArray = new Array();

    // Split up the search term string based on the space character
    termArray = terms.split(" ");

    // Create a variable to hold our resulting URI-safe value
    var result = "";

    // Loop through the search terms
    for(var i=0; i<termArray.length; i++)
    {
        // All search terms (after the first one) are to be separated with a '+'
        if(i > 0)
            result += "+";

        // Encode each search term, using the built-in Firefox function
        // encodeURIComponent().
        result += encodeURIComponent(termArray[i]);
    }

    return result; // Return the result
}

//******************************************************************
// The WendellFreeLibraryTB_LoadURL() function loads the specified URL in the browser.
//******************************************************************
function WendellFreeLibraryTB_LoadURL(url,target)
{
    //WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_LoadURL('"+url+"','"+target+"')");
    if (window.name != target && target != "")
	window.open(url,target);
    else {
	    // Set the browser window's location to the incoming URL
	    window._content.document.location = url;

	    // Make sure that we get the focus
	    window.content.focus();
    }
}

//******************************************************************
// WendellFreeLibraryTB_InsertUniqueMenuItem inserts into the menu the item
// if it is not already there.
//******************************************************************
function WendellFreeLibraryTB_InsertUniqueMenuItem(menu,text)
{
        if (!WendellFreeLibraryTB_HasMenuItem(menu,text)) {
	  // Create a new menu item to be added
	  var tempItem = document.createElement("menuitem");
	  // Set the new menu item's label
	  tempItem.setAttribute("label", text);
	  // Add the item to our menu
          menu.appendChild(tempItem);
	}
}

//******************************************************************
// WendellFreeLibraryTB_HasMenuItem searches menu for a menu item with the
// specified text
//******************************************************************
function WendellFreeLibraryTB_HasMenuItem(menu,text)
{
	if (menu.hasChildNodes()) {
	  var children = menu.childNodes;
	  for (var i = 0; i < children.length; i++)
	  {
	      var item = children[i];
	      if (item.getAttribute("label") == text) return true;
	  }
	}
	return false;
}
	
//******************************************************************
// Load saved search history, if not already loaded
//******************************************************************
function WendellFreeLibraryTB_ConditionallyLoadSavedHistory()
{
	try {
		WendellFreeLibraryTB_LoadSearchHistory();
	} catch (e) {
		WendellFreeLibraryTB_Log("Problem loading search history ("+e+"), continuing...");
	}
}

//******************************************************************
// Return the target for shortcuts
//******************************************************************
function WendellFreeLibraryTB_GetTarget()
{
	return WendellFreeLibraryTB_target;
}


//******************************************************************
// Preferences menuitem handler
//******************************************************************
function WendellFreeLibraryTB_Preferences()
{
	window.openDialog(
		"chrome://wendelllibrarytoolbar/content/preferenceDialog.xul",
		"Preferences",
		"chrome,dialog,centerscreen,dependent");
}

//******************************************************************
// Preferences acceptence callback
//******************************************************************
function WendellFreeLibraryTB_PreferencesAccepted()
{
	WendellFreeLibraryTB_Log("*** WendellFreeLibraryTB_PreferencesAccepted()");
	// Refetch preference values
	WendellFreeLibraryTB_maxhistory   = WendellFreeLibraryTB_Branch.getIntPref("maxhistory");
	WendellFreeLibraryTB_target       = WendellFreeLibraryTB_Branch.getCharPref("target");
	if (WendellFreeLibraryTB_maxhistory > 0) {
	  var sh = WendellFreeLibraryTB_SearchHistory;
	  for (var count=1; sh != null && 
			      count < WendellFreeLibraryTB_maxhistory; count++) {
	    sh = sh.next;
	  }
	  if (sh != null) {
	    sh.next = null;
	    WendellFreeLibraryTB_SaveSearchHistory();
	  }
	}
	return true;	
}
//******************************************************************
// About menuitem handler
//******************************************************************
function WendellFreeLibraryTB_About()
{
	window.openDialog(
		"chrome://wendelllibrarytoolbar/content/about.xul",
		"About",
		"chrome,dialog,centerscreen,dependent");
}


